OpenCV - Bug # 308: VideoWriter FFmpeg libs incompatible with VS 2008

Status: Done Priority: High
Author: Marcus Wirsing Category: highgui-video
Created: 2010-04-25 Assignee:
Updated: 2012-08-16 Due date:
Affected version:
Difficulty:
Pull request:
Operating System:
HW Platform:
Description: (Visual Studio 2008 SP1, Win XP 32 Bit)
When execute the following Code:
0//int x = CV_FOURCC('M','J','P",'G");
Oint x = CV_FOURCC('X','V','I''D");
0
0Mat im = imread("C:\\test2.jpg"); //640x480
a
0 VideoWriter *vw = new [[VideoWriter]]();
0vw->open("test.avi",x,25.0,im.size());
0bool b = vw->isOpened();
Ofor(int i=0;i<100;i++)
0{
00 (*vw)<<im;
0}
Odelete vw;
| get an access violation reading location Oxffffffff in
cvWriteFrame (opencv_ffmpeg210d.dil) and the console says:
"Compiler did not align stack variables. Libavcodec has been miscompiled and may be very slow or crash.
This is not a bug in libavcodec,but in the compiler. You may try recompiling using gcc >= 4.2.Do not report
crashes to FFmpeg developers."
My solution is to recompile the static ffmpeg libraries:
1. Get the latest ffmpeg from SVN.
2. Compile ffmpeg with mingw
configure --enable-memalign-hack
(See: http:/ffmpeg.arrozcru.org/wiki/index.php?title=Static)
3. Recompile opencv with the new ffmpeg libs(VS 2008) - and it
should work.
History

2010-04-25 12:41 pm - Marcus Wirsing

My gcc Version is 4.4.0

2010-05-07 02:22 am - michaelp -

Can you upload your ffmpeg build? | can't get mine to run with opencv (unresolved external symbol _img_convert).
2010-05-07 05:27 pm - Marcus Wirsing
Replying to [comment:2 michaelp]:
> Can you upload your ffmpeg build? | can't get mine to run with opencv (unresolved external symbol _img_convert).

You must define HAVE_FFMPEG_SWSCALE in opencv_ffmpeg, and replace the old ffmpeg headers with the new. You must also replace the mingw
specific libs and include
the libswscale.a.

See:

http://rapidshare.com/files/384609847/patch.zip.html

(OpenCV Rev: 3045,

FFmpeg Rev:23053 [configure --enable-memalign-hack --disable-debug])

2010-05-08 06:41 pm - michaelp -

Replying to [comment:3 heso]:

> You must define HAVE_FFMPEG_SWSCALE in opencv_ffmpeg, and replace the old ffmpeg headers with the new. You must also replace the mingw
specific libs and include

> the libswscale.a.

>

> See:

> http://rapidshare.com/files/384609847/patch.zip.html

> (OpenCV Rev: 3045,

> FFmpeg Rev:23053 [configure --enable-memalign-hack --disable-debug])

>

Thanks, | managed to compile by sticking with 0.5 which does not require any modification except for the proper configure command.

2010-10-14 09:15 am - anonymous -

For this problem:

"Compiler did not align stack variables. Libavcodec has been miscompiled and may be very slow or crash. This is not a bug in libavcodec,but in the
compiler. You may try recompiling using gcc >= 4.2.Do not report crashes to FFmpeg developers."

My solution is replace binaries of .\3rdparty\lib\:

-libavcodec.a, libavdevice.a,libavformat.a,libavutil.a

with previous version found in [[OpenCv]]2.0

Now coding it works.

Rudy

2011-06-16 06:52 pm - Andrey Morozov
- Status changed from Open to Done

- (deleted custom field) set to obsolete

working in the latest version

2012-08-16 04:33 pm - Andrey Kamaev
- Category changed from highgui-images to highgui-video
